## regina-normal 6.0.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 3.12)
PROJECT (regina)

# Let the user override the package name.
IF(NOT PACKAGE_NAME)
  SET (PACKAGE_NAME regina CACHE STRING
    "The package name used for installation directories.  On some platforms this is 'regina-normal', not 'regina', to avoid conflicts with other software with the same name."
    FORCE)
ENDIF(NOT PACKAGE_NAME)

SET (PACKAGE_PRETTY_NAME Regina)
# Look here for Find___.cmake modules
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

# Version
SET (PACKAGE_VERSION 6.0.1)
SET (SNAPPY_VERSION 2.4)
SET (PACKAGE_STRING "${PACKAGE_PRETTY_NAME} ${PACKAGE_VERSION}")

# Extract major/minor version
# Note: The PACKAGE_VERSION_MAJOR "output" is discarded, since it matches the
# whole string
STRING(REGEX MATCH "^([0-9]+).([0-9]+)" PACKAGE_VERSION_MAJOR "${PACKAGE_VERSION}")
SET (PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1} )
SET (PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2} )

# Make a release build by default.
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build.  Options are: Debug Release RelWithDebInfo MinSizeRel."
  FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(LOWDIMONLY "OFF" CACHE BOOL INTERNAL)
IF(LOWDIMONLY)
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DREGINA_LOWDIMONLY")
ENDIF(LOWDIMONLY)

# Every year I swear I will drop windows support, and this year is no different.
# The windows build (as of November 2015) crashes in the test suite with -O3.
# It looks as though this might be a compiler problem: the ipa-cp-clone
# optimisation has been known to cause crashes under mingw in other projects
# in the past also.
IF (WIN32)
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-ipa-cp-clone")
ENDIF (WIN32)

# Distinguish between the different Regina installation types:
# XDG = standard freedesktop.org filesystem installation in a fixed location.
# Windows = self-contained movable install directory for MS Windows.
if (NOT REGINA_INSTALL_TYPE)
  if (WIN32)
    SET (REGINA_DEFAULT_INSTALL_TYPE Windows)
  else ()
    SET (REGINA_DEFAULT_INSTALL_TYPE XDG)
  endif ()
  SET (REGINA_INSTALL_TYPE ${REGINA_DEFAULT_INSTALL_TYPE} CACHE STRING
    "Choose how Regina installs itself.  Options are: XDG Windows."
    FORCE)
ENDIF (NOT REGINA_INSTALL_TYPE)
MESSAGE (STATUS "Regina install type: ${REGINA_INSTALL_TYPE}")

# Sanity check the installation type, and set the boolean install type flags
# that will appear in regina-config.h.
# Note: even though Bundle is not supported in CMake, we must keep the flag
# here because the Xcode build uses it (via the corresponding #define).
SET(REGINA_INSTALL_XDG FALSE)
SET(REGINA_INSTALL_BUNDLE FALSE)
SET(REGINA_INSTALL_WINDOWS FALSE)
IF (${REGINA_INSTALL_TYPE} STREQUAL XDG)
  # No sanity checking needed here (yet).
  SET(REGINA_INSTALL_XDG TRUE)
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL Bundle)
  MESSAGE(FATAL_ERROR
    "REGINA_INSTALL_TYPE=Bundle is no longer supported. These CMake build scripts will give a unix-style installation in a fixed location; for a standalone macOS app bundle please use Xcode instead.")
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL Windows)
  IF (NOT WIN32)
    MESSAGE(FATAL_ERROR
      "REGINA_INSTALL_TYPE=Windows is only supported on MS Windows.")
  ENDIF (NOT WIN32)
  SET(REGINA_INSTALL_WINDOWS TRUE)
ELSE()
  MESSAGE(FATAL_ERROR
    "REGINA_INSTALL_TYPE must be either XDG or Windows.")
ENDIF()

# Are we installing development files?
SET (REGINA_INSTALL_DEV ON)

# Give packagers a way of insisting that every optional component is found.
# Set PACKAGING_MODE=1 to make every component compulsory.
IF(NOT PACKAGING_MODE)
  SET (PACKAGING_MODE OFF CACHE STRING
    "Makes all optional components mandatory, so that cmake will fail if any optional component is not found."
    FORCE)
ENDIF(NOT PACKAGING_MODE)
IF(PACKAGING_MODE)
  SET(REGINA_MANDATORY TRUE)
ELSE(PACKAGING_MODE)
  SET(REGINA_MANDATORY FALSE)
ENDIF(PACKAGING_MODE)

# Options that indicate how python is shipped.
IF(NOT PYTHON_CORE_IN_ZIP)
  SET (PYTHON_CORE_IN_ZIP OFF CACHE STRING
    "Indicates that Regina ships its own Python, with the core Python libraries in pythonXY.zip."
    FORCE)
ENDIF(NOT PYTHON_CORE_IN_ZIP)

# The iOS build of Regina links the python module directly into the GUI,
# and there is a flag in regina-config.h to indicate this.
# Such a configuration is not, however, supported by regina's cmake build
# system, and so we do not allow cmake users to enable it.
SET (PYTHON_STATIC_LINK OFF)

# For pretty logging of optional features at the end of the cmake run:
INCLUDE(MacroLogFeature)

# Modules needed for IOS check and function existence
INCLUDE( CheckCXXSourceCompiles )
INCLUDE( CheckFunctionExists )

# We need to determine threading flags *before* testing for C++11 std::thread.
FIND_PACKAGE(Threads REQUIRED)
IF(NOT Threads_FOUND)
  MESSAGE(FATAL_ERROR "Regina requires threading support.")
ENDIF(NOT Threads_FOUND)
IF(CMAKE_COMPILER_IS_GNUCXX)
  # The FindThreads module picks up -lpthread, not -pthread.
  # This is unfortunate, because std::thread must be built with -pthread
  # under g++; otherwise it builds but throws an exception at runtime.
  SET(CMAKE_CXX_FLAGS "-pthread ${CMAKE_CXX_FLAGS}")
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

# Make sure we have std::thread (which has in the past been missing on windows).
INCLUDE(CheckCXX11Features)
SET(HAVE_CXX11_FEATURES TRUE)
NEED_CXX11_FEATURE("stdthread")
IF(NOT HAVE_CXX11_FEATURES)
  MESSAGE(FATAL_ERROR "Regina requires full C++11 support, including std::thread, to compile.")
ENDIF()

# Make everything use C++14 (or later).
SET(CMAKE_CXX_STANDARD 14)
SET(CMAKE_CXX_STANDARD_REQUIRED YES)
SET(CMAKE_CXX_EXTENSIONS OFF)

# Regina's own cmake scripts:
INCLUDE( ReginaMacros )

# Always include . in the header search path:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Installation directories
if (${REGINA_INSTALL_TYPE} STREQUAL Windows)
  # MS Windows install.
  SET (APPDIR ${CMAKE_INSTALL_PREFIX}/bin)
  SET (BINDIR ${CMAKE_INSTALL_PREFIX}/bin)
  SET (LIBDIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
  SET (DATADIR ${CMAKE_INSTALL_PREFIX}/share)
  SET (INCLUDEDIR ${CMAKE_INSTALL_PREFIX}/include/${PACKAGE_NAME})
  SET (PKGDATADIR ${DATADIR}/${PACKAGE_NAME})
  SET (PYLIBDIR ${LIBDIR}/${PACKAGE_NAME}/python)
else ()
  # Full install.
  SET (APPDIR ${CMAKE_INSTALL_PREFIX}/bin)
  SET (BINDIR ${CMAKE_INSTALL_PREFIX}/bin)
  SET (LIBDIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
  SET (DATADIR ${CMAKE_INSTALL_PREFIX}/share)
  SET (INCLUDEDIR ${CMAKE_INSTALL_PREFIX}/include/${PACKAGE_NAME})
  SET (PKGDATADIR ${DATADIR}/${PACKAGE_NAME})
  UNSET (PYLIBDIR)
endif ()
SET (HTMLDIR ${PKGDATADIR}/docs)
SET (ICONDIR ${DATADIR}/icons)
SET (MANDIR ${DATADIR}/man)
SET (XDG_APPS_INSTALL_DIR ${DATADIR}/applications)
SET (XDG_MIME_INSTALL_DIR ${DATADIR}/mime/packages)

# Useful build directories
SET (ENGINE_INCLUDES "${PROJECT_SOURCE_DIR}/engine" )
SET (ENGINE_LIBRARY regina-engine)

# RPATH support.
IF (NOT DISABLE_RPATH)
  SET(DISABLE_RPATH OFF CACHE BOOL
    "Do not build with rpath.  This option may break installations in non-standard directories, since executables may be unable to find Regina's libraries.  For installations in standard areas such as /usr however, this option is highly recommended." FORCE)
ENDIF (NOT DISABLE_RPATH)

IF (NOT DISABLE_RPATH)
  if (APPLE)
    set(CMAKE_INSTALL_NAME_DIR ${LIBDIR})
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  else (APPLE)
    set(CMAKE_INSTALL_RPATH ${LIBDIR} )
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  endif (APPLE)
ENDIF (NOT DISABLE_RPATH)

# i18n checks.
CHECK_CXX_SOURCE_COMPILES("
  #include \"langinfo.h\"
  int main() { nl_langinfo(CODESET); return 0; }"
  LANGINFO_FOUND )
if(NOT LANGINFO_FOUND)
  MESSAGE(WARNING "langinfo not found: UTF-8 will be used always, and the locale-specific encoding will be ignored.")
endif(NOT LANGINFO_FOUND)

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  int128_t x;
  uint128_t y;
  int main() { return 0; }"
  INTERNAL_INT128_T_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  __int128 x;
  __uint128 y;
  int main() { return 0; }"
  INTERNAL___INT128_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  __int128_t x;
  __uint128_t y;
  int main() { return 0; }"
  INTERNAL___INT128_T_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  unsigned long long x = 0xFFFFFFFFFFFFFFFF;
  int main() { return 0; }"
  NUMERIC_64_FOUND)
CHECK_CXX_SOURCE_COMPILES("
  unsigned long long x = 0xFFFFFFFFFFFFFFFFLL;
  int main() { return 0; }"
  NUMERIC_64_LL_FOUND)

# Dependencies used by all components of Regina

# Note that pkg-config is optional, but it does help us find some libraries
# that we could perhaps not have found otherwise.
# In particular, most build environments will need it to locate Graphviz.
FIND_PACKAGE(PkgConfig)

FIND_PACKAGE(ZLIB)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
MACRO_LOG_FEATURE(ZLIB_FOUND
  "zlib"
  "Essential: compression support"
  "http://www.gzip.org/zlib/"
  TRUE)

FIND_PACKAGE(LibXml2)
INCLUDE_DIRECTORIES(${LIBXML2_INCLUDE_DIR})
MACRO_LOG_FEATURE(LIBXML2_FOUND
  "libxml2"
  "Essential: XML support"
  "ftp.gnome.org"
  TRUE)

FIND_PACKAGE(GMP)
INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR})
MACRO_LOG_FEATURE(GMP_FOUND
  "GMP/C"
  "Essential: large integer arithmetic support for C"
  "http://gmplib.org/"
  TRUE)

FIND_PACKAGE(GMPXX)
INCLUDE_DIRECTORIES(${GMPXX_INCLUDE_DIR})
MACRO_LOG_FEATURE(GMPXX_FOUND
  "GMP/C++"
  "Essential: large integer arithmetic support for C++"
  "http://gmplib.org/"
  TRUE)

FIND_PACKAGE(ICONV)
INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})
MACRO_LOG_FEATURE(ICONV_FOUND
  "iconv"
  "Essential: internationalisation support"
  "http://www.gnu.org/s/libiconv/"
  TRUE)

FIND_PACKAGE(Jansson)
INCLUDE_DIRECTORIES(${JANSSON_INCLUDE_DIR})
MACRO_LOG_FEATURE(JANSSON_FOUND
  "Jansson"
  "Essential: JSON support"
  "http://www.digip.org/jansson/"
  TRUE)

FIND_PACKAGE(Boost 1.55)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
MACRO_LOG_FEATURE(Boost_FOUND
  "Boost (>= 1.55)"
  "Essential: C++ components (headers only)"
  "http://www.boost.org/"
  TRUE)

IF (NOT DISABLE_PYTHON)
  MESSAGE (STATUS "Searching for a Python installation")

  # Some basic sanity testing on the user's python settings.
  IF (PYTHON_EXECUTABLE)
    UNSET(PYTHON_EXECUTABLE CACHE)
    MESSAGE(FATAL_ERROR "Regina now uses a different method for finding Python. The old PYTHON_EXECUTABLE setting is no longer recognised. Please set Python_EXECUTABLE instead.")
  ENDIF (PYTHON_EXECUTABLE)
  IF (Python_EXECUTABLE)
    IF(${CMAKE_VERSION} VERSION_LESS "3.16.0")
      UNSET(Python_EXECUTABLE CACHE)
      MESSAGE(FATAL_ERROR "The Python_EXECUTABLE setting only works with CMake 3.16 and above. For now please either upgrade your CMake, or else remove (or temporarily hide) any conflicting Python installations so that the automated tools can find the correct Python without assistance.")
    ENDIF(${CMAKE_VERSION} VERSION_LESS "3.16.0")
  ENDIF (Python_EXECUTABLE)

  FIND_PACKAGE(Python COMPONENTS Interpreter Development REQUIRED)

  IF (Python_FOUND)
    IF (${Python_VERSION_MAJOR} EQUAL 2)
      IF (${Python_VERSION_MINOR} LESS 6)
        MESSAGE(FATAL_ERROR "For Python 2.x, Regina needs Python >= 2.6.")
      ENDIF ()
    ELSEIF (${Python_VERSION_MAJOR} EQUAL 3)
      IF (${Python_VERSION_MINOR} LESS 1)
        MESSAGE(FATAL_ERROR "For Python 3.x, Regina needs Python >= 3.1.")
      ENDIF ()
    ELSE ()
      MESSAGE(FATAL_ERROR "Unknown Python major version: ${Python_VERSION_MAJOR}")
    ENDIF ()
  ENDIF (Python_FOUND)
ENDIF (NOT DISABLE_PYTHON)

FIND_PACKAGE(TokyoCabinet)
MACRO_LOG_FEATURE(TOKYOCABINET_FOUND
  ${TOKYOCABINET_DISPLAYNAME}
  "Essential: lightweight database library for census data"
  ${TOKYOCABINET_DISPLAYURL}
  TRUE)

# Dependencies used by only some components of Regina
FIND_PACKAGE(POPT)
MACRO_LOG_FEATURE(POPT_FOUND
  "Popt"
  "Essential: command-line option processing"

=== engine/CMakeLists.txt ===
# Engine

# Note: Any flags that need to be picked up by internal compiled engine tools
# (such as mkcensusdb) need to appear *before* the list of subdirectories.

# Pick up generated engine headers (e.g., regina-config.h) as well as
# Regina's standard engine headers.
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/engine)
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/engine)

# The tokyocabinet library is only used internally by the engine (i.e., it
# never appears in the engine headers, only the .cpp sources).
# Therefore we include it only here within engine/, not globally.
INCLUDE_DIRECTORIES(${TOKYOCABINET_INCLUDE_DIRS})
LINK_DIRECTORIES(${TOKYOCABINET_LIBRARY_DIRS})

SET ( SOURCES )
# Each of these subdirectories modifies the SOURCE variable,
# adding more source files
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("core")
ADD_SUBDIRECTORY("data")
ADD_SUBDIRECTORY("dim2")
ADD_SUBDIRECTORY("dim4")
ADD_SUBDIRECTORY("enumerate")
ADD_SUBDIRECTORY("file")
ADD_SUBDIRECTORY("foreign")
ADD_SUBDIRECTORY("generic")
ADD_SUBDIRECTORY("hypersurface")
ADD_SUBDIRECTORY("libnormaliz")
ADD_SUBDIRECTORY("link")
ADD_SUBDIRECTORY("manifold")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("packet")
ADD_SUBDIRECTORY("progress")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("split")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surfaces")
ADD_SUBDIRECTORY("syntax")
ADD_SUBDIRECTORY("treewidth")
ADD_SUBDIRECTORY("triangulation")
ADD_SUBDIRECTORY("utilities")

# Some C files need to be compiled using the C++ compiler (e.g., snappea,
# where we have added C++ namespaces).
SET_SOURCE_FILES_PROPERTIES( ${SOURCES_C_AS_CPP} PROPERTIES LANGUAGE CXX )

ADD_DEFINITIONS(-DREGINA_DLL_EXPORTS=1)

ADD_LIBRARY("regina-engine" SHARED ${SOURCES} )
# All of the libraries that appear in ENGINE_LINK_LIBRARIES feature in
# the engine headers, which means they may be expose to third-party apps
# that build against libregina-engine.
# Note: PUBLIC and PRIVATE only appeard in CMake 2.8.12.
# For compatibility back to 2.8.7 we use LINK_PUBLIC and LINK_PRIVATE instead.
SET(ENGINE_LINK_LIBRARIES ${LIBXML2_LIBRARIES} ${GMP_LIBRARIES} ${GMPXX_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
TARGET_LINK_LIBRARIES(regina-engine
  LINK_PUBLIC ${ENGINE_LINK_LIBRARIES}
  LINK_PRIVATE ${ICONV_LIBRARY} ${ZLIB_LIBRARIES} ${JANSSON_LIBRARIES} ${TOKYOCABINET_LIBRARIES})
SET_TARGET_PROPERTIES(regina-engine PROPERTIES VERSION ${PACKAGE_VERSION})
SET_TARGET_PROPERTIES(regina-engine PROPERTIES SOVERSION ${PACKAGE_VERSION})

SET( HEADERS ${HEADERS} docs.h engine.h output.h regina-core.h )
SET( MANS ${MANS} regina-engine-config.1 )

# Build space-separated lists of flags for regine-engine-config:
GET_DIRECTORY_PROPERTY(ENGINE_INCLUDE_DIRECTORIES DIRECTORY .. INCLUDE_DIRECTORIES)
foreach(arg ${ENGINE_INCLUDE_DIRECTORIES})
  SET(RECONFIG_INCLUDE_FLAGS "${RECONFIG_INCLUDE_FLAGS} -I${arg}")
endforeach(arg ${ENGINE_INCLUDE_DIRECTORIES})
foreach(arg ${ENGINE_LINK_LIBRARIES})
  SET(RECONFIG_LINK_FLAGS "${RECONFIG_LINK_FLAGS} ${arg}")
endforeach(arg ${ENGINE_LINK_LIBRARIES})
CONFIGURE_FILE (
  regina-engine-config.in
  "${PROJECT_BINARY_DIR}/engine/regina-engine-config"
  @ONLY
)

INSTALL(TARGETS regina-engine
  LIBRARY DESTINATION ${LIBDIR}
  RUNTIME DESTINATION ${BINDIR}
  COMPONENT Runtime)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES ${HEADERS} DESTINATION ${INCLUDEDIR} COMPONENT Development)
  INSTALL(FILES ${CMAKE_BINARY_DIR}/engine/regina-config.h DESTINATION ${INCLUDEDIR} COMPONENT Development)
  INSTALL(PROGRAMS ${PROJECT_BINARY_DIR}/engine/regina-engine-config DESTINATION bin COMPONENT Development)
  INSTALL(FILES regina-engine-config.1 DESTINATION ${MANDIR}/man1 COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

# Miscellaneous extras:
ADD_SUBDIRECTORY("doxygen")

=== examples/CMakeLists.txt ===

SET(examplesdir ${PKGDATADIR}/examples)

SET(examples_files
  README.txt
  closed-hyp-census.rga
  closed-or-census.rga
  closed-nor-census.rga
  cusped-hyp-or-census.rga
  cusped-hyp-nor-census.rga
  knot-census.rga
  )
INSTALL(FILES ${examples_files} DESTINATION ${examplesdir})

# Files that come with different versions for python 2 vs python 3:

SET(py23_files
  sample-pyX.rga
  progress-pyX.py
  progress-pyX.session
  tree-pyX.py
  tree-pyX.session
  triangulation-pyX.py
  triangulation-pyX.session
  )

IF (Python_FOUND)
  IF ("${Python_VERSION_MAJOR}" EQUAL 3)
    SET (PYX py3)
  ELSEIF ("${Python_VERSION_MAJOR}" EQUAL 2)
    SET (PYX py2)
  ELSE ()
    MESSAGE(FATAL_ERROR "Unknown Python version: ${Python_VERSION_MAJOR}")
  ENDIF ()
ENDIF (Python_FOUND)

FOREACH (FILE ${py23_files})
  STRING (REPLACE "-pyX" "-${PYX}" _SRC "${FILE}")
  STRING (REPLACE "-pyX" "" _DEST "${FILE}")
  INSTALL(FILES ${_SRC} DESTINATION ${examplesdir} RENAME ${_DEST})
ENDFOREACH (FILE ${py23_files})

=== python/CMakeLists.txt ===
SET ( SOURCES globalarray modulemain )
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("dim2")
ADD_SUBDIRECTORY("dim3")
ADD_SUBDIRECTORY("dim4")
ADD_SUBDIRECTORY("file")
ADD_SUBDIRECTORY("foreign")
ADD_SUBDIRECTORY("generic")
ADD_SUBDIRECTORY("hypersurface")
ADD_SUBDIRECTORY("link")
ADD_SUBDIRECTORY("manifold")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("packet")
ADD_SUBDIRECTORY("progress")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("split")
ADD_SUBDIRECTORY("srcutils")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surfaces")
ADD_SUBDIRECTORY("treewidth")
ADD_SUBDIRECTORY("utilities")

ADD_SUBDIRECTORY("testsuite")
ADD_SUBDIRECTORY("sage")

# The module itself is built in the regina/ subdirectory, so that we can
# import the module directly from the source tree if we like.
ADD_SUBDIRECTORY("regina")

# The startup script for users:
CONFIGURE_FILE (
  "${PROJECT_SOURCE_DIR}/python/regina-python.in"
  "${PROJECT_BINARY_DIR}/python/regina-python"
  @ONLY
)

INSTALL(PROGRAMS ${PROJECT_BINARY_DIR}/python/regina-python DESTINATION ${BINDIR} COMPONENT Runtime)

=== testsuite/CMakeLists.txt ===
# Give the test suite a way to locate the data files shipped with
# Regina's calculation engine.
SET_PROPERTY ( DIRECTORY
  PROPERTY COMPILE_DEFINITIONS
    TESTSUITE_CENSUS_DIR=\"${PROJECT_BINARY_DIR}/engine/data/census\"
)

SET ( SOURCES
  exhaustive
  runalltests
  testsuite
  )
# Each of these subdirectories modifies the SOURCES variable,
# adding more source files
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("dim2")
ADD_SUBDIRECTORY("dim3")
ADD_SUBDIRECTORY("dim4")
IF(NOT LOWDIMONLY)
  ADD_SUBDIRECTORY("generic")
ENDIF(NOT LOWDIMONLY)
ADD_SUBDIRECTORY("link")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surfaces")
ADD_SUBDIRECTORY("utilities")

INCLUDE_DIRECTORIES(${ENGINE_INCLUDES})
INCLUDE_DIRECTORIES(${CPPUNIT_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/engine)
ADD_EXECUTABLE(regtestsuite ${SOURCES})
TARGET_LINK_LIBRARIES(regtestsuite ${ENGINE_LIBRARY} ${CPPUNIT_LIBRARY}) # TODO

ADD_TEST(cpp-test regtestsuite)

=== timing/CMakeLists.txt ===

include_directories(${ENGINE_INCLUDES})
include_directories(${CMAKE_BINARY_DIR}/engine)

set(TIMING_APPS
  loadlarge
  tree
  )

foreach(APP ${TIMING_APPS})
  string(REGEX REPLACE _ - SOURCE_FILE ${APP})
  add_executable(${APP} ${SOURCE_FILE})
  target_link_libraries(${APP} ${ENGINE_LIBRARY})
endforeach(APP)

=== utils/CMakeLists.txt ===
include_directories(${ENGINE_INCLUDES})
include_directories(${CMAKE_BINARY_DIR}/engine)
include_directories(${POPT_INCLUDE_DIR})

set(UTILS
  censuslookup
  regconcat
  regconvert
  regfiledump
  regfiletype
  retriangulate
  sigcensus
  tricensus
  trisetcmp
  )

foreach(UTIL ${UTILS})
  string(REGEX REPLACE _ - SOURCE_FILE ${UTIL})
  add_executable(${UTIL} ${SOURCE_FILE})
  target_link_libraries(${UTIL} ${ENGINE_LIBRARY} ${POPT_LIBRARY})
endforeach(UTIL)

install(TARGETS ${UTILS} DESTINATION ${BINDIR} COMPONENT Runtime)

=== docs/engine/CMakeLists.txt ===

# TODO: The doxygen files generated in the build tree are not removed
# by "make clean".

ADD_CUSTOM_COMMAND(OUTPUT index.html
  COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_BINARY_DIR}/engine/doxygen/docs.conf
  COMMAND cp `find "${PROJECT_SOURCE_DIR}/engine" -name '*.png'` .
  )

ADD_CUSTOM_TARGET(docs ALL DEPENDS index.html)

INSTALL(
  DIRECTORY ${PROJECT_BINARY_DIR}/docs/engine/
  DESTINATION ${PKGDATADIR}/engine-docs
  FILES_MATCHING
  PATTERN CMakeFiles EXCLUDE
  PATTERN "*.css"
  PATTERN "*.dot"
  PATTERN "*.gif"
  PATTERN "*.html"
  PATTERN "*.jpg"
  PATTERN "*.js"
  PATTERN "*.png"
  PATTERN "*.txt"
  )

=== docs/man/CMakeLists.txt ===

SET(man1dir ${MANDIR}/man1)

SET(man1_files
  censuslookup.1
  regconcat.1
  regconvert.1
  regfiledump.1
  regfiletype.1
  retriangulate.1
  sigcensus.1
  tricensus.1
  trisetcmp.1
  regina-gui.1
  regina-python.1
  )
INSTALL(FILES ${man1_files} DESTINATION ${man1dir} COMPONENT Runtime)

=== engine/angle/CMakeLists.txt ===
# angle

# Files to compile
SET ( FILES
  anglestructure
  anglestructures
  xmlanglestructreader
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} angle/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    anglestructure.h
    anglestructures.h
    nanglestructure.h
    nanglestructurelist.h
    xmlanglestructreader.h
    DESTINATION ${INCLUDEDIR}/angle COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/census/CMakeLists.txt ===
# census

# Files to compile
SET ( FILES
  census
  closedprimemin
  compact
  euler
  gluingperms
  gluingpermsearcher2
  gluingpermsearcher3
  gluingpermsearcher4
  hyperbolic
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} census/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    census.h
    dim2gluingperms.h
    dim2gluingpermsearcher.h
    dim4gluingperms.h
    dim4gluingpermsearcher.h
    gluingperms.h
    gluingperms-impl.h
    gluingpermsearcher.h
    gluingpermsearcher2.h
    gluingpermsearcher3.h
    gluingpermsearcher4.h
    ncensus.h
    ngenericgluingperms.h
    ngenericgluingperms-impl.h
    ngluingperms.h
    ngluingpermsearcher.h
    DESTINATION ${INCLUDEDIR}/census COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/core/CMakeLists.txt ===
# Files to compile
SET ( FILES engine )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} core/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    engine.h
    output.h
    DESTINATION ${INCLUDEDIR}/core COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== debian/changelog ===
regina-normal (6.0.1-4) unstable; urgency=low

  * Additional polish for the appstream metadata:
      - move the screenshots to people.debian.org and give them captions;
      - avoid the <code/> tag, which can cause problems with appstream-glib.

 -- Ben Burton <bab@debian.org>  Mon, 19 Apr 2021 18:07:50 +1000

regina-normal (6.0.1-3) unstable; urgency=low

  * Removed the icon tags from the appstream metadata.

 -- Ben Burton <bab@debian.org>  Mon, 19 Apr 2021 00:23:51 +1000

regina-normal (6.0.1-2) unstable; urgency=low

  * Added appstream metadata.

 -- Ben Burton <bab@debian.org>  Sun, 18 Apr 2021 12:51:30 +1000

regina-normal (6.0.1-1) unstable; urgency=low

  * New upstream bugfix release.
  * Fixes an issue for Python users, where the Triangulation3 constructor
    could become unusable in the graphical user interface.

 -- Ben Burton <bab@debian.org>  Thu, 11 Feb 2021 09:02:55 +1000

regina-normal (6.0-2) unstable; urgency=low

  * Added autopkgtests: these test the mathematical engine, the python
    bindings, and the command-line utilities.

 -- Ben Burton <bab@debian.org>  Sun,  7 Feb 2021 18:16:33 +1000

regina-normal (6.0-1) unstable; urgency=low

  * New upstream release.
  * Bumped standards-version to 4.5.1 (no changes required).

 -- Ben Burton <bab@debian.org>  Sat,  9 Jan 2021 12:12:06 +1000

regina-normal (5.96-1) unstable; urgency=low

  * New upstream release.
  * Fixed crash in Link::homfly() on some 32-bit architectures.

 -- Ben Burton <bab@debian.org>  Tue, 22 Dec 2020 22:19:10 +1000

regina-normal (5.95-1) unstable; urgency=low

  * New upstream release.
  * Removed regina-normal-mpi, since Regina no longer ships with MPI utilities.
  * Updated to build against python3 (closes: #938346)
  * Now build-depends on cmake >= 3.12.
  * Now requires only the boost headers, not any pre-built boost libraries
    (closes: #962070).

 -- Ben Burton <bab@debian.org>  Mon, 21 Dec 2020 16:34:12 +1000

=== debian/control ===
Source: regina-normal
Section: math
Priority: optional
Maintainer: Ben Burton <bab@debian.org>
Homepage: http://regina-normal.github.io/
Build-Depends:
    debhelper (>= 11),
    dh-python,
    cmake (>= 3.12),
    doxygen,
    libboost-dev,
    libcppunit-dev (>= 1.10.2-4),
    libgmp-dev (>= 4.1.4-10),
    libgraphviz-dev,
    libjansson-dev,
    libpopt-dev,
    libqt5svg5-dev,
    libtokyocabinet-dev,
    libxml2-dev,
    pkg-config,
    python3-all-dev,
    qtbase5-dev,
    shared-mime-info,
    xsltproc,
    zlib1g-dev,
    dpkg-dev (>= 1.16.0)
Standards-Version: 4.5.1

Package: regina-normal
Architecture: any
Section: math
Pre-Depends: ${misc:Pre-Depends}
Depends:
    ${shlibs:Depends},
    ${perl:Depends},
    ${python3:Depends},
    ${misc:Depends}
Recommends: regina-normal-doc (>= 6.0.1-0), gap, evince | pdf-viewer
Suggests: regina-normal-dev
Description: mathematical software for low-dimensional topology
 Regina is a software package for 3-manifold and 4-manifold topologists,
 with a focus on triangulations, knots and links, normal surfaces, and
 angle structures.
 .
 For 3-manifolds, it includes high-level tasks such as 3-sphere recognition,
 connected sum decomposition and Hakenness testing, comes with a rich
 database of census manifolds, and incorporates the SnapPea kernel for
 working with hyperbolic manifolds.  For 4-manifolds, it offers a range of
 combinatorial and algebraic tools, plus support for normal hypersurfaces.
 For knots and links, Regina can perform combinatorial manipulation,
 compute knot polynomials, and work with several import/export formats.
 .
 Regina comes with a full graphical user interface, as well as Python bindings
 and a low-level C++ programming interface.
 .
 This package includes the graphical user interface and the command-line
 Python interface.  The users' handbook and the API documentation are in
 the separate package regina-normal-doc.

Package: regina-normal-dev
Architecture: any
Section: libdevel
Depends:
    regina-normal (= ${binary:Version}),
    libboost-dev,
    libgmp-dev,
    libxml2-dev,
    zlib1g-dev,
    ${misc:Depends}
Suggests: regina-normal-doc
Description: development files for Regina, the topology software
 Regina is a software package for low-dimensional topologists.  This package
 provides development files for compiling Regina's mathematical engine into
 other projects.
 .
 The calculation engine is provided as a C++ shared library.  For complete
 API documentation, see the package regina-normal-doc.
 .
 Regina focuses on the study of 3-manifold and 4-manifold triangulations,
 knots and links, normal surfaces, and angle structures.  For Regina's
 standard graphical user interface, and for more information about what
 Regina can do, see the package regina-normal.

Package: regina-normal-doc
Architecture: all
Section: doc
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Recommends: iceweasel | www-browser
Suggests: regina-normal, regina-normal-dev
Breaks: regina-normal (<< 4.6-2)
Replaces: regina-normal (<< 4.6-2)
Description: documentation for Regina, the topology software
 Regina is a software package for low-dimensional topologists.  This package
 provides a rich users' handbook, complete API documentation for the C++
 calculation engine and Python bindings, and the full specification for
 Regina's XML data file format.
 .
 Regina focuses on the study of 3-manifold and 4-manifold triangulations,
 knots and links, normal surfaces, and angle structures.  For Regina's
 standard graphical user interface, and for more information about what
 Regina can do, see the package regina-normal.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with python3

# Upgrade optimisation flags:
export DEB_CFLAGS_MAINT_STRIP = -O2
export DEB_CXXFLAGS_MAINT_STRIP = -O2
export DEB_CFLAGS_MAINT_APPEND = -O3 -DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG

# Find the default python version so we can pass it to cmake.  This 
# keeps things sane when multiple python*-dev packages are installed.
pyver = $(subst python,,$(shell /usr/bin/py3versions --default))

DEB_HOST_MULTIARCH ?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPACKAGE_NAME=regina-normal -DPACKAGING_MODE=1 \
		-DPython_EXECUTABLE=/usr/bin/python${pyver} \
		-DDISABLE_RPATH=1

override_dh_auto_build:
	dh_auto_build -- VERBOSE=1

override_dh_auto_test:
	dh_auto_test -- ARGS=-V

override_dh_missing:
	dh_missing --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.txt

override_dh_compress:
	dh_compress -X.bz2 -X.css -X.docbook -X.rga

override_dh_strip_nondeterminism:
	# PNGs are not compiled during the build, so do not touch them now.
	dh_strip_nondeterminism -X.png

=== debian/tests/control ===
Test-Command: debian/tests/utils-test censuslookup
Features: test-name=utils-censuslookup

Test-Command: debian/tests/utils-test regconcat
Features: test-name=utils-regconcat

Test-Command: debian/tests/utils-test regconvert
Features: test-name=utils-regconvert

Test-Command: debian/tests/utils-test regfiledump
Features: test-name=utils-regfiledump

Test-Command: debian/tests/utils-test regfiletype
Features: test-name=utils-regfiletype

Test-Command: debian/tests/utils-test retriangulate
Features: test-name=utils-retriangulate

Test-Command: debian/tests/utils-test trisetcmp
Features: test-name=utils-trisetcmp

Test-Command: debian/tests/python-test alltypes
Features: test-name=python-alltypes

Test-Command: debian/tests/python-test constructors
Features: test-name=python-constructors

Test-Command: debian/tests/python-test embeddings
Features: test-name=python-embeddings

Test-Command: debian/tests/python-test equality
Features: test-name=python-equality

Test-Command: debian/tests/python-test euler
Features: test-name=python-euler

Test-Command: debian/tests/python-test facenumbering
Features: test-name=python-facenumbering

Test-Command: debian/tests/python-test file python/testsuite
Features: test-name=python-file

Test-Command: debian/tests/python-test generic
Features: test-name=python-generic

Test-Command: debian/tests/python-test groups
Features: test-name=python-groups

Test-Command: debian/tests/python-test hypersurfaces
Features: test-name=python-hypersurfaces

Test-Command: debian/tests/python-test i18n python/testsuite
Features: test-name=python-i18n

Test-Command: debian/tests/python-test integer
Features: test-name=python-integer

Test-Command: debian/tests/python-test iterators
Features: test-name=python-iterators

Test-Command: debian/tests/python-test listener
Features: test-name=python-listener

Test-Command: debian/tests/python-test memory1
Features: test-name=python-memory1

Test-Command: debian/tests/python-test memory2
Features: test-name=python-memory2

Test-Command: debian/tests/python-test memory3
Features: test-name=python-memory3

Test-Command: debian/tests/python-test misc
Features: test-name=python-misc

Test-Command: debian/tests/python-test orb python/testsuite
Features: test-name=python-orb

Test-Command: debian/tests/python-test pdf python/testsuite
Features: test-name=python-pdf

Test-Command: debian/tests/python-test safeheldtype_basic
Features: test-name=python-safeheldtype_basic

Test-Command: debian/tests/python-test safeheldtype_packet
Features: test-name=python-safeheldtype_packet

Test-Command: debian/tests/python-test skeleton
Features: test-name=python-skeleton

Test-Command: debian/tests/python-test surfaces
Features: test-name=python-surfaces

Test-Command: debian/tests/python-test trigeneral
Features: test-name=python-trigeneral

Test-Command: debian/tests/python-test utf8
Features: test-name=python-utf8
